AppTitle "X-Mas Chaos -by Sheldon & TimBo"
Graphics3D 1024, 768, 32, 2
SeedRnd MilliSecs()
Global timer = CreateTimer(60)
SetBuffer BackBuffer()
HidePointer()



Dim Sound(3)
For i=0 To 3
    Sound(i)=LoadSound("sfx\"+i+".wav")
Next
Include "includes\wurf.bb"

;3D settings
Include "includes\d3d.bb"


Global camera=CreateCamera()
CameraClsColor camera,0,0,0
TurnEntity camera,0,180,0 ;camera wegdrehen
effect=1
winkel_camera#=180
light=CreateLight()
DrawInit3D(camera)
Origin3D(1024,768)


;geschenke
Type present
	Field x
	Field y
End Type
Global anzahl_geschenke,geschenk_mod

Type baum
	Field x
	Field y
	Field anzahl
End Type

Type smann
	Field x
	Field y
	Field last_throw
End Type

Type jump
	Field x
	Field y
End Type

Type rutsch
	Field x
	Field y
	Field modus
End Type

;Daten auslesen
Global mapFile = ReadFile("maps\map.map") 
Global AnzahlMaps = ReadByte(mapFile) 
DebugLog AnzahlMaps
Dim Namen$(AnzahlMaps)
For i = 1 To AnzahlMaps
	Namen(i) = ReadString(mapFile)
Next
Global offset = FilePos(mapFile)
Global levelSelect = 1
;tiles
Dim mapdata(49,29,3)
;Mapdate(x,y,0)=grafik
;Mapdate(x,y,1)=gameplay
;Mapdate(x,y,2)=kollision
;Mapdate(x,y,3)=spawn

Global  player_geschenk_status

;Bilder
Global winter = loadimage3D("gfx\winterlandschaft.jpg",4,2,1)
Global schnee_img=loadimage3D("gfx\gauss.png",2,2,1)
Global menueSelect = 0, menueFertig = 0, menueEintraege$[3]
menueEintraege[0] = "Spielen"
menueEintraege[1] = "Map Editor"
menueEintraege[2] = "Credits"
menueEintraege[3] = "Beenden"


Global tiles = LoadImage3D("gfx\tileset.png",4,2,1)
For ii=0 To 11
	For i=0 To 5
		GrabImage3D(tiles,i*20,ii*20,20,20)
	Next
Next


Global player = LoadImage3D("gfx\player.png",4,2,1)
GrabImage3D player,0,0,30,30
uswap3D player
loadimage3D("gfx\player2.png",4,2,1)


Global mann=LoadImage3D("gfx\schnee_mann.png",4,2,1)
Global geschenk=LoadImage3D("gfx\geschenk.png",4,2,1)

Global schnee_img2=loadimage3D("gfx\glass.png",2,2,1)

Global menu2= LoadImage3D("gfx\menu.png",2,2,1)
GrabImage3D menu2,0,0,1024,768

Global b3d = LoadImage3D("gfx\b3d.png")

Global Schrift = LoadFont3D("fonts/punk2.png"  ,2,2,1)
Global schrift2= loadFont3D("fonts/master1.png",2,2,1)
Global Schrift3= LoadFont3D("fonts/babylon2.png"  ,2,2,1)


Global cursor = LoadImage3D("gfx\zippelmtze.bmp",4,2,1)
For i=0 To 3
	grabimage3D(cursor,i*20,0,20,30)
Next
Global cursorFrame = 0, CFpm = 1, CFpt


;Variablen fr das erste Men
Global mouse_over
Global mouse_alt 
Global menu_scale#
Global menu_modus#
Global selected_menu=1
Global old_lvl_select
Global mx, my,mh1



Dim schnee#(599, 5)
;bla, 0 = x
;bla, 1 = y
;bla, 2 = ySpeed
;bla, 3 = r
;bla, 4 = g
;bla, 5 = b


;1 = zwischen Meneintrgen wechseln
;2 = besttigen
Const kUp = 200
Const kLeft = 203
Const kRight = 205
Const kDown = 208

;sonstiges
Global playerx#,playerx_spawn
Global playery#,playery_spawn
Global gravity = 5
Global start_time
Global dauer
Global menu_active
Global menu_pos_y

Global old_in_game
Global selected_in_game

Global jump_speed#

For i = 0 To 599
    schnee#(i, 0) = Rand(-512,512)
    schnee#(i, 1) = Rand(0,768)
    schnee#(i, 2) = Rnd(1,5)
	schnee#(i, 3) = Rand(0,255)
    schnee#(i, 4) = Rand(0,255)
    schnee#(i, 5) = Rand(0,255)
Next


CFpt = MilliSecs()
menu_scale#=1
menu_modus#=.02


While 1
	;einblend Effect
    If effect=1 Then TurnEntity(camera,0,1.5,0):winkel_camera#=winkel_camera#-1.5
	If winkel_camera#=0 Then effect=0
	
	
	;Mauskoordinaten
	mx = MouseX()-512
	my = 384-MouseY()
	mh1= MouseHit(1)
	Select selected_menu
		Case 1
			menu1()
			background()
			schnee_sim(0)
			maus()
			
		Case 2
			levelwahl()
			background()
			schnee_sim(0)
			maus()
			
		Case 3
			background()	
			schnee_sim(0)
			drawmap()
			If anzahl_geschenke>0 Then geschenke()
			baum_func()
			game_play()
			get_time()
			schnee_mann()
			maus()
			boing()
			in_game_menu()
			start_physik()
			
		Case 4
			;background()
			schnee_sim(1)
			hgw()
			maus()
			in_game_menu()
			
		Case 5
			credit()
			schnee_sim(1)
			maus()
			in_game_menu()
	End Select
	
	RenderWorld()
	
	
	WaitTimer timer
	clear3d()
	Flip 0:Cls
	Cls
	
Wend


End


;Mens

Function menu1()
	If mouse_alt <> mouse_over
		mouse_alt = mouse_over
		PlaySound(Sound(1))
	EndIf
	
	SetFont3D(1.5,1,0,0)
	ColorT3D 255,255,0,0.8
	Text3D Schrift, 0, 300, "Hauptmenu",1 
	
    ;Meneintrge
	wubble_effect()
	
	For i=0 To 3
		If my-37<=100 - i * 75 Then menueSelect=i :mouse_over=i
	Next
	
	For i = 0 To 3
		If menueSelect = i Then ColorT3D 255,0,0,0.8 : Else ColorT3D 255,255,255,0.8
		Text3D Schrift, 0,100 - i * 75, menueEintraege[i],1
	Next
	
	
	If mh1
		PlaySound(Sound(0))
		Select menueSelect
			Case 0
				selected_menu=2
			Case 1
				ExecFile "Editor.exe"
				
			Case 2
				selected_menu=5
			Case 3
				Delay 100 : End
		End Select
	EndIf
End Function

Function levelwahl()
	SetFont3D(1.5,1,0,0)
	ColorT3D 255,255,0,0.8
	Text3D Schrift, 0, 300, "Levelauswahl",1 
	levelSelect = (220 - my)/50
	If old_lvl_select <> levelSelect And levelSelect > 0 And levelSelect <= AnzahlMaps Then PlaySound(Sound(1))
	old_lvl_select=levelSelect
	
	wubble_effect(0)
	For i = 1 To AnzahlMaps
		If levelSelect = i Then ColorT3D 255,0,0,0.8 : Else ColorT3D 255,255,255,0.8
		Text3D Schrift3, 0, 200 - i * 50, Namen(i), 1 
		;Schauen, ob eine andere ausgewaehlt wurde
	Next
	If my>220 Then colorT3D 255,0,0,.8  Else colorT3D 255,255,255,.8
	text3D Schrift, 445, 328, "Back", 1
	
	If mh1 
		If levelSelect <= AnzahlMaps And levelSelect>0 
			PlaySound(Sound(0)) : selected_menu=3 :loadmap()
			
		ElseIf my>220
			PlaySound(Sound(0)) : selected_menu=1
		EndIf
	EndIf
	
End Function

Function credit()
	DrawImage3D b3d,440,330,0,0,.3
	setfont3d 1.0
	text3D Schrift3,0,250,"Credits",1
	
	SetFont3D 0.7
	text3D Schrift3,-502, 100,"Idee, Konzept, Maps und Grafik"
	text3d Schrift3,-502, -75,"Programmierung"
	text3d Schrift3,-502,-250,"Besonderen *Dank* geht an"
	
	
	SetFont3D 0.6
	text3D Schrift3,-452,  50,"Sheldon"
	text3d Schrift3,-452,-125,"Tim Borowski (TimBo)"
	text3d Schrift3,-452,-300,"Hectic und seiner Draw3D"
	
End Function

;Background
Function schnee_sim(bunt)
	 ;schnee
	If bunt=0 Then
		colorn3D(255,255,255)
		For i = 0 To 599
			schnee#(i, 1) = schnee#(i, 1) + schnee#(i, 2)
			If schnee#(i, 1) >768 Then  schnee#(i,1) = -50
			plot3D(schnee_img,schnee#(i,0),348-schnee#(i,1),schnee#(i,2))
		Next
	Else
		For i = 0 To 599
			schnee#(i, 1) = schnee#(i, 1) + schnee#(i, 2)
			If schnee#(i, 1) >768 Then  schnee#(i,1) = -50
			colorN3D(schnee(i,3),schnee(i,4),schnee(i,5))
			plot3D(schnee_img,schnee#(i,0),348-schnee#(i,1),schnee#(i,2)+2)
		Next
	EndIf
	
End Function

Function background()
		;background
	drawimage3D(winter,0,0)
End Function

Function maus()
	If MilliSecs() >= CFpt + 150 Then
		cursorFrame = cursorFrame + CFpm
		If cursorFrame = 0 Then CFpm = 1
		If cursorFrame = 2 Then CFpm = -1
		
		CFpt = MilliSecs()
	EndIf
	drawimage3D(cursor,mx,my,0,0,1,cursorFrame+1)
End Function

Function drawmap();new
	For i=0 To 49
		For ii=0 To 29
			DrawImage3D(tiles,i*20-490,348-ii*20,0,0,1,mapdata(i,ii,0))
		Next
	Next
End Function

;Laden
Function loadmap();new
	;lschen
	anzahl_geschenke=0
	For p.present=Each present
		Delete p.present
	Next
	For b.baum=Each baum
		Delete b.baum
	Next
	For s.smann=Each smann
		Delete s.smann
	Next
	For j.jump = Each jump
		Delete j.jump
	Next
	
	
	SeekFile(mapFile,offset+(levelSelect-1)*6004)
	playerx_spawn=ReadShort(mapFile)*20 -512
	playery_spawn=384-ReadShort(mapFile)*20
	playerx=playerx_spawn
	playery=playery_spawn
	
	
	For x=0 To 49
		For y=0 To 29
			For i=0 To 3
				mapdata(x,y,i)=ReadByte(mapFile)
			Next
			
			;schneemann
			If mapdata(x,y,3)=1
				s.smann = New smann
				s\x=x
				s\y=y
				s\last_throw=Rand(0,120)
			EndIf
			
			;geschenk
			If mapdata(x,y,3)=2
				anzahl_geschenke=anzahl_geschenke+1
				p.present = New present
				p\x=x
				p\y=y
			EndIf
			
			;baum
			If mapdata(x,y,1)=2
				b.baum = New baum
				b\x=x
				b\y=y
			EndIf
			
			;jumper
			If mapdata(x,y,1)=5
				j.jump = New jump
				j\x=x
				j\y=y
			EndIf
			
			;rutsch
			If mapdata(x,y,1)=3 Or mapdata(x,y,1)=4 
				r.rutsch  = New rutsch
				r\x=x
				r\y=y
				r\modus=mapdata(x,y,1)
			EndIf
			
		Next
	Next
	new_geschenk()
	start_time=MilliSecs()
	menu_active=0
End Function


;effects
Function wubble_effect(size=0)
	If menu_scale#>1.5 Then menu_modus#=-.02
	If menu_scale#<1   Then menu_modus#=.02
	menu_scale#=menu_scale#+menu_modus#
	SetFont3D(1,menu_scale+size,0,0)
End Function

Function game_play()
	richtung=2
	speed#=1
	For r.rutsch = Each rutsch
		x=r\x*20-492
		y=368-r\y*20
		If Sqr((playerx-x)^2+(playery-y)^2)<14 Then 
			If r\modus=3 Then 
				speed#=1.4
			Else
				speed#=0.6
			EndIf
		EndIf 
	Next
	
	
	If KeyDown(kLeft) Then playerx=playerx-5*speed# :richtung=0
	If KeyDown(kRight)Then playerx=playerx+5*speed# :richtung=1
	
	If playery<=-215 Then playerx=playerx_spawn : playery=playery_spawn
	If playery>=358     Then playery=358
	If playerx<-480    Then playerx=-480
	If playerx>= 500    Then playerx= 499
	
	
	
	
	If mapdata( Abs(-490-(playerx))/20, (348-(playery-20+gravity))/20, 2) = 0 Then playery = playery-gravity
	If KeyDown(kUp  ) And mapdata(Abs(-490-(playerx))/20, Abs(348-(playery   ))/20, 1) Then playery=playery+5
	If KeyDown(kDown) And mapdata(Abs(-490-(playerx))/20, (348-(playery-20))/20, 1)    Then playery=playery-5
	
	playery=playery+jump_speed#
	
	DrawImage3D(player,playerx,playery,0,0,1,richtung)
End Function

Function schnee_mann()
	For s.smann = Each smann
		x=s\x*20-490
		y=348-s\y*20
		DrawImage3D(mann,x,y)
		If Abs(playery-y)<20 And s\Last_throw=0 Then new_flugbahn(x,playerx,y) : s\Last_throw=240
		If s\Last_throw>0 Then s\Last_throw = s\Last_throw -1
	Next
End Function

Function geschenke()
	p.present=First present
	For i=1 To geschenk_mod
		p = After p
	Next
	x=p\x*20-490
	y=368-p\y*20
	DrawImage3D(geschenk,x,y)
	If player_geschenk_status = 0
		If Sqr((playerx-x)^2+(playery-y)^2)<20 Then new_geschenk() : player_geschenk_status=1 :PlaySound(Sound(2))
	Else
		DrawImage3D(geschenk,playerx,playery)
	EndIf
End Function

Function new_geschenk()
	geschenk_mod = Rand(0,anzahl_geschenke-1)
End Function

Function baum_func()
	voll=1
	setfont3d(1)
	For b.baum = Each baum
		x=b\x*20-490
		y=368-b\y*20
		Text3D(Schrift,x,y+10,b\anzahl,1)
		If player_geschenk_status=1 And b\anzahl<10
			If Sqr((playerx-x)^2+(playery-y)^2)<20 Then b\anzahl=b\anzahl+1 : player_geschenk_status=0 :PlaySound(Sound(1))
		EndIf
		
		If b\anzahl<10 Then voll=0
		
	Next
	If voll=1
		selected_menu=4
		dauer=MilliSecs()-start_time
	EndIf
End Function

Function get_time()
	setfont3d(2)
	text3D(Schrift,-512,300,(MilliSecs()-start_time)/1000)
End Function

Function hgw()
	setfont3d(1)
	text3d(schrift2,0,200, "Herzlichen Glueckwunsch!",1)
	text3d(schrift2,0,0,   "Du hast Weihnachten in",1)
	text3d(schrift2,0,-200,dauer/1000+" sek gerettet",1)
End Function

Function in_game_menu()
	Select menu_active
		Case 0
			If my>350 Then menu_active=1 : menu_pos_y=70
			DrawImage3D(menu2,0,70,0,0,1,1)
			
		Case 1
			menu_pos_y=menu_pos_y-3
			DrawImage3D(menu2,0,menu_pos_y,0,0,1,1)
			If menu_pos_y<=0 Then menu_active=2
			
		Case 2
			DrawImage3D(menu2,0,0,0,0,1,1)
			If my<300 Then menu_active=3
			
			If mx>0 Then SetFont3D(.7):selected_in_game=0 Else SetFont3D(.9)
			text3d Schrift,-150,344,"Zur Levelauswahl",1
			
			If mx<0 Then SetFont3D(.7):selected_in_game=1 Else SetFont3D(.9)
			text3d Schrift, 150,344,"Zum Hauptmenu",1
			
			If old_in_game<>selected_in_game Then PlaySound(Sound(2)):old_in_game=selected_in_game
			
			If mh1 Then
				If mx>0 Then 
					menu_active=0 : selected_menu=1
				Else
					menu_active=0 : selected_menu=2
				EndIf
				PlaySound(Sound(0))
			EndIf
			
		Case 3
			menu_pos_y=menu_pos_y+3
			DrawImage3D(menu2,0,menu_pos_y,0,0,1,1)
			If menu_pos_y>=70 Then menu_active=0
	End Select
End Function

Function boing()
	For j.jump = Each jump
		x=j\x*20-492
		y=368-j\y*20
		If Sqr((playerx-x)^2+(playery-y)^2)<14 Then jump_speed#=30
	Next
	If jump_speed>0 Then 
		jump_speed#=jump_speed#-2
	EndIf
End Function
;~IDEal Editor Parameters:
;~F#F7#11E#13A#14D#161#166#171#17A#1C7#1CE#1F2#1FC#20B#20F#223#228#22F#256
;~C#Blitz3D