Graphics 1024,768,16,2
SetBuffer BackBuffer()
timer = CreateTimer(60)

fahne = LoadImage ("gfx_editor\fahne.png")


;das Tileset
Global tileset = LoadAnimImage("gfx_editor\tileset.png",20,20,0,68)
MaskImage tileset,1,1,1

Global counter

Global schnee =LoadImage("gfx_editor\schnee.png")
Global geschenk = LoadImage("gfx_editor\geschenk.png")
save = LoadImage("gfx_editor\speichern.png")
load = LoadImage("gfx_editor\laden.png")
Global kollision = LoadImage ("gfx_editor\k.png")

Dim modus(4)
For i=0 To 4
	modus(i)=LoadImage("gfx_editor\"+(i+1)+".png")
Next


Dim mapdata(49,29,3)
;Mapdate(x,y,0)=grafik
;Mapdate(x,y,1)=gameplay
;Mapdate(x,y,2)=kollision
;Mapdate(x,y,3)=spawn


;1 = leiter
;2 = baum 
;3 = ausrutschen
;4 = langsam

For i=0 To 49
	For ii=0 To 29
		mapdata(i,ii,0)=68
	Next
Next

Global font = LoadFont ("arial",20)

;das Rasterbild
Global raster =CreateImage(1000,768)
update_world()

Const k = 37
Const s = 31
Const g = 34
Const n = 49

Const leer=57

Global spawnx,spawny

Global show_detail = 1

Repeat
	;mausstatus
	mx = MouseX()
	my = MouseY()
	mh1=MouseHit(1)
	md1 = MouseDown(1)
	mz = MouseZSpeed()
	
	
	;auswahl des Tiles
	selected = selected+mz
	If selected > 67 Then Selected =0
	If Selected < 0  Then Selected =67
	
	
	
	;rastermalen
	DrawImage raster,0,0
	
	
	;wenn maus auf Feld
	If mx<1000 And my<600
		auswahlx = mx/20
		auswahly = my/20
		If md1 Then 
			mapdata(auswahlx,auswahly,0)=selected+1
			mapdata(auswahlx,auswahly,1)=modi
			mapdata(auswahlx,auswahly,2)=kollisions_selected
			mapdata(auswahlx,auswahly,3)=spawnmod
			
			update_world()
		EndIf
	EndIf
	
	;alle mglichen sonder feautrs
	If KeyHit(k) Then kollisions_selected = Not kollisions_selected
	
	If KeyHit(n) Then spawnmod=0
	If KeyHit(s) Then spawnmod=1
	If KeyHit(g) Then spawnmod=2
	
	If KeyHit(2) Then Modi=1
	If KeyHit(3) Then modi=2
	If KeyHit(4) Then modi=3
	If KeyHit(5) Then modi=4
	If KeyHit(6) Then modi=5
	If KeyHit(11) Then modi=0
	
	
	
	If KeyHit(leer) Then spawnx=mx/20 :spawny=my/20
	DrawImage fahne,spawnx*20-20,spawny*20-20
	
	
	
	If KeyHit(29) Then show_detail = Not show_detail:update_world()
	SetFont font
	Color 255,255,255
	Text 0,600,"Sonderzeichen werden angezeigt "+show_detail+" (Strg links drcken, um Sonderzeichen anzuzeigen)"
	
	DrawImage save,0,718
	If mx<100 And my>=718 And mh1=1 Then save_map()
	
	DrawImage load,102,718
	If mx<200 And mx>100 And my>=718 And mh1=1 Then load_map()
	
	;ausgewhltes Bild malen
	DrawImage tileset,mx,my,selected 
	Color 0,0,0
	Select spawnmod
		Case 1
			DrawImage schnee,mx,my
		Case 2
			DrawImage geschenk,mx,my
	End Select
	If modi>0 Then DrawImage modus(modi-1),mx,my
	If kollisions_selected Then DrawImage kollision,mx,my
	
	Color 255,0,0
	;Print mx
	;Print my
	
	If md1=1 Then
		If mx>700 And mx<900 And my>=602 And my<=742 Then selected=(mx-700)/20+(my-602)/20*10
	EndIf  
	
	WaitTimer (timer)
	Flip(0) : Cls
Until KeyHit(1)

End

Function update_world()
	SetBuffer ImageBuffer(raster)
	SetFont font
	Color 0,0,0
	For i = 0 To 49
		For ii = 0 To 29
			If mapdata(i,ii,0)>0
				DrawImage tileset,i*20,ii*20,mapdata(i,ii,0)-1
			EndIf
			If show_detail=1
				If mapdata(i,ii,2) Then DrawImage kollision,i*20,ii*20
				Select mapdata(i,ii,3)
					Case 1
						DrawImage schnee,i*20,ii*20
					Case 2
						DrawImage geschenk,i*20,ii*20
				End Select
				If mapdata(i,ii,1)>0 Then DrawImage modus(mapdata(i,ii,1)-1),i*20,ii*20
			EndIf
		Next
	Next
	Color 255,0,0
	For i=0 To 50
		Line i*20,0,i*20,600
	Next
	For i=0 To 30
		Line 0,i*20,1000,i*20
	Next
	Rect 0,0,1000,600,0
	
	Color 255,255,255
	
	Text 300,630,"Tasten / Funktionen"
	Text 300,650,"1 fr Leiter"
	Text 300,665,"2 fr Weihnachtsbaum"
	Text 300,680,"3 fr rutschig"
	Text 300,695,"4 fr langsam"
	Text 300,710,"5 fr sprung"
	Text 300,725,"0 fr normal"
	
	Text 500,630,"Tasten / Spawn"
	Text 500,650,"g fr Geschenk"
	Text 500,665,"s fr Schneemann"
	Text 500,680,"n fr nichts"
	
	Text 500,710,"Tasten / Sonstiges"
	Text 500,730,"k fr Kollsion an/aus"
	Text 500,745,"Leertaste fr Spielerstartpunkt setzen"
	
	counter=0
	For j = 0 To 5
		For i = 0 To 9
			DrawImage tileset, 700 + i*20, 602 + j * 20, counter
			counter=counter+1
		Next
	Next
	For i = 0 To 7
		DrawImage tileset, 700 + i*20, 722, 60+i
	Next
	
	SetBuffer BackBuffer()
End Function

Function save_map()
	Color 255,255,0
	SetFont font
	path$=Input("bitte Namen eingeben: bsp. map123.map  ")
	If FileType("Editor Maps\"+path$)<>0 Then
		ersetze=Input("Datei existiert bereits, soll sie berschrieben werden? 1=Ja 0=Nein ")
		If ersetze = 1 Then
			DeleteFile path$
		Else
			Print "Fehler beim erstellen der Map"
			WaitKey()
			Return
		EndIf
	EndIf
	datei=WriteFile ("Editor Maps\"+path$)
	WriteString datei,Input ("Mapname eingeben bsp. Schne Weihnachten  ")
	WriteShort datei,spawnx
	WriteShort datei,spawny
	For x = 0 To 49
		For y = 0 To 29
			For i=0 To 3
				WriteByte datei,mapdata(x,y,i)
			Next
		Next
	Next
End Function

Function load_map()
	SetFont font
	FlushKeys()
	Locate 0,0
	lesen=ReadFile("Editor Maps\"+Input("Bitte Map Namen eingeben ")):FlushKeys()
	If lesen=0 Then Print "No DATA found 404" : WaitKey() :Return
	ReadString(lesen)
	spawnx=ReadShort(lesen)
	spawny=ReadShort(lesen)
	
	For x=0 To 49
		For y=0 To 29
			For i=0 To 3
				mapdata(x,y,i)=ReadByte (lesen)
			Next
		Next
	Next
	update_world()
End Function
;~IDEal Editor Parameters:
;~B#17#DC#E5#E6#E7#E8#EC
;~C#Blitz3D