;Werte vorberechnen = mehr Speed
Dim berechnet_x# (18)
Dim berechnet_y# (18)
For i=0 To 18
	berechnet_x (i)=Cos(i*10)
	berechnet_y (i)=+Sin(i*10)
Next

;Type erstellen
Type flug
	Field punkte_x[18]
	Field punkte_y[18]
	Field ballx
	Field bally
	Field place
	Field richtung
End Type


Function new_flugbahn(x1,x2,y) ;erstellt einen neue Fluglaufbahn
	f.flug = New flug
	abstand# = Abs(x1-x2)
	radius#=abstand#/4
	
	If x1<x2
		small=x1
		f\richtung=1
		f\place=0;startposition
	Else
		small=x2
		f\richtung=-1
		f\place=18 ;startposition
	EndIf
	
	For i=0 To 18
		f\punkte_x[i] = (abstand#/18)*i+small
		f\punkte_y[i] = berechnet_y#(i)*radius# +y
	Next
	
	If f\richtung=1
		f\ballx=f\punkte_x[0];startkordinate
		f\bally=f\punkte_y[0]
	Else
		f\ballx=f\punkte_x[18];startkordinate
		f\bally=f\punkte_y[18]
	EndIf
	
	
End Function

Function show_flugbahnen(); visualisiert diese Laufbahn (B2D)
	For f.flug=Each flug
		For i=0 To 18
			Plot f\punkte_x[i] , f\punkte_y[i]
		Next
	Next
End Function

Function start_physik(); startet den Wurf
	For f.flug = Each flug
		abstand1# = f\ballx-f\punkte_x[f\place]
		abstand2# = f\bally-f\punkte_y[f\place]
		
		winkel= (ATan2(abstand2#,abstand1#)+360)Mod 360
		f\ballX=f\ballX-Cos(winkel)*5
		f\ballY=f\ballY-Sin(winkel)*5
		plot3d(schnee_img2,f\ballx,f\bally,10)
		
		If Sqr((playerx-f\ballx)^2+(playery-f\bally)^2)<20 Then If player_geschenk_status=1 Then PlaySound(sound(3)) :player_geschenk_status=0 :Delete f.flug:Goto ende
		
		If Sqr((abstand1#*abstand1#)+(abstand2#*abstand2#))<6 Then f\place=f\place+f\richtung
		If f\place>18 Or f\place<0 Then Delete f.flug
		.ende
	Next
	
End Function
;~IDEal Editor Parameters:
;~F#9
;~C#Blitz3D